/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
ldse@hendriklipka.de
*/

package de.hendriklipka.ldse.client.admin.ui;

import java.awt.*;

import de.hendriklipka.ldse.client.admin.FrameAdminHandler;

public class FrameAdmin extends java.awt.Frame 
{
	static java.util.ResourceBundle frameAdminBundle = java.util.ResourceBundle.getBundle("de.hendriklipka.ldse.client.admin.ui.FrameAdminBundle");

	public FrameAdmin()
	{
		setLayout(null);
		setBackground(java.awt.Color.lightGray);
		setSize(400,217);
		setVisible(false);
		labelAddress.setText(frameAdminBundle.getString("labelAddress_text"));
		add(labelAddress);
		labelAddress.setBounds(12,18,100,18);
		labelPort.setText(frameAdminBundle.getString("labelPort_text"));
		add(labelPort);
		labelPort.setBounds(12,48,100,18);
		labelPassword.setText(frameAdminBundle.getString("labelPassword_text"));
		add(labelPassword);
		labelPassword.setBounds(12,78,100,18);
		labelAction.setText(frameAdminBundle.getString("labelAction_text"));
		add(labelAction);
		labelAction.setBounds(12,108,100,18);
		labelParameter.setText(frameAdminBundle.getString("labelParameter_text"));
		add(labelParameter);
		labelParameter.setBounds(12,138,100,18);
		add(textFieldAddress);
		textFieldAddress.setText("127.0.0.1");
		textFieldAddress.setBounds(132,12,240,24);
		textFieldPort.setText("7623");
		add(textFieldPort);
		textFieldPort.setBounds(132,42,240,24);
		add(textFieldPassword);
		textFieldPassword.setBounds(132,72,240,24);
		add(textFieldParameter);
		textFieldParameter.setBounds(132,132,240,24);
		choiceAction.setBackground(java.awt.Color.white);
		add(choiceAction);
		choiceAction.setBounds(132,102,240,25);
		buttonDo.setLabel(frameAdminBundle.getString("buttonDo_label"));
		add(buttonDo);
		buttonDo.setBounds(12,168,102,36);
		buttonClose.setLabel(frameAdminBundle.getString("buttonClose_label"));
		add(buttonClose);
		buttonClose.setBounds(174,168,102,36);
		buttonHelp.setLabel(frameAdminBundle.getString("buttonHelp_label"));
		add(buttonHelp);
		buttonHelp.setBounds(282,168,102,36);
		setTitle(frameAdminBundle.getString("FrameAdmin_title"));

		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		buttonClose.addActionListener(lSymAction);
		buttonDo.addActionListener(lSymAction);
		buttonHelp.addActionListener(lSymAction);

		initChoiceBox();
	}

	public FrameAdmin(String title)
	{
		this();
		setTitle(title);
	}

    public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
		super.setVisible(b);
	}

	static public void main(String args[])
	{
	  FrameAdmin _frame=new FrameAdmin();
	  _frame._handler=new de.hendriklipka.ldse.client.admin.FrameAdminHandler();
	  _frame.setVisible(true);
	}
	
	public void addNotify()
	{
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		Insets insets = getInsets();
		setSize(insets.left + insets.right + d.width, insets.top + insets.bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets.left, insets.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	boolean fComponentsAdjusted = false;

	java.awt.Label labelAddress = new java.awt.Label();
	java.awt.Label labelPort = new java.awt.Label();
	java.awt.Label labelPassword = new java.awt.Label();
	java.awt.Label labelAction = new java.awt.Label();
	java.awt.Label labelParameter = new java.awt.Label();
	java.awt.TextField textFieldAddress = new java.awt.TextField();
	java.awt.TextField textFieldPort = new java.awt.TextField();
	java.awt.TextField textFieldPassword = new java.awt.TextField();
	java.awt.TextField textFieldParameter = new java.awt.TextField();
	java.awt.Choice choiceAction = new java.awt.Choice();
	java.awt.Button buttonDo = new java.awt.Button();
	java.awt.Button buttonClose = new java.awt.Button();
	java.awt.Button buttonHelp = new java.awt.Button();

    de.hendriklipka.ldse.client.admin.FrameAdminHandler _handler=null;
  
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == FrameAdmin.this)
				FrameAdmin_WindowClosing(event);
		}
	}
	
	void FrameAdmin_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);
		System.exit(0);
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == buttonClose)
				buttonClose_ActionPerformed(event);
			else if (object == buttonDo)
				buttonDo_ActionPerformed(event);
			else if (object == buttonHelp)
				buttonHelp_ActionPerformed(event);
		}
	}

	void buttonClose_ActionPerformed(java.awt.event.ActionEvent event)
	{
		buttonClose_ActionPerformed_Interaction1(event);
	}

	void buttonClose_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
	  FrameAdmin_WindowClosing(null);
	}

	void buttonDo_ActionPerformed(java.awt.event.ActionEvent event)
	{
	  String actionText="";
	  try
	  {
	    buttonClose.setEnabled(false);
	    buttonDo.setEnabled(false);

	    _handler.setAddress(textFieldAddress.getText());
	    _handler.setPort(textFieldPort.getText());
	    _handler.setPassword(textFieldPassword.getText());
	    if (_handler.isError())
	    {
	      Dialog d=new AttentionDialog(this,frameAdminBundle.getString("Fehler"),_handler.getErrorText());
	      return;
	    }
	    int action=-1;
	    String s=choiceAction.getSelectedItem();
	    for (int i=0;i<_actionMap.length;i++)
	    {
	      if(s.equals(_actionMap[i]._name))
	      {
	        action=_actionMap[i]._id;
    	    actionText=createActionText(_actionMap[i]._text);
	        break;
	      }
	    }
	    if (-1==action)
	    {
	      Dialog d=new AttentionDialog(this,frameAdminBundle.getString("Fehler"),frameAdminBundle.getString("interner_Fehler__unbekannte_Aktion"));
	      return;
	    }
	    _handler.execute(action,textFieldParameter.getText());
	    if (_handler.isError())
	    {
	      Dialog d=new AttentionDialog(this,frameAdminBundle.getString("Fehler"),_handler.getErrorText());
	      return;
	    }
	    else
	    {
	      if(FrameAdminHandler.GETDOCUMENTSFORSPIDER==action)
	      {
	        FrameDocumentList lister=new FrameDocumentList(frameAdminBundle.getString("FrameAdmin_FrameDocumentList_lister_new_FrameDocumentList"));
	        String[] sa=_handler.getDocuments();
	        for (int i=0;i<sa.length;i++)
	        {
	          lister.addDocument(sa[i]);
	        }
	        lister.setVisible(true);
	        return;
	      }
	      else
	      {
	        Dialog d=new AttentionDialog(this,frameAdminBundle.getString("Erfolg"),actionText);
	        return;
	      }
	    }
	  }
	  finally
	  {
	    buttonClose.setEnabled(true);
	    buttonDo.setEnabled(true);
	  }
	}

	void buttonHelp_ActionPerformed(java.awt.event.ActionEvent event)
	{
	  FrameHelp frame=new FrameHelp(frameAdminBundle.getString("FrameAdmin_FrameHelp_frame_new_FrameHelp"));
	  frame.setVisible(true);
	}
	
	protected String createActionText(String text)
	{
	  String s=text;
	  int pos=s.indexOf("%P%");
	  if (-1!=pos)
	  {
	    s=s.substring(0,pos)+textFieldParameter.getText()+s.substring(pos+3);
	  }
	  pos=s.indexOf("%A%");
	  if (-1!=pos)
	  {
	    s=s.substring(0,pos)+textFieldAddress.getText()+s.substring(pos+3);
	  }
	  return s;
	}
	
	void initChoiceBox()
	{
	  _actionMap=new ActionMapEntry[9];
		_actionMap[0]=new ActionMapEntry(frameAdminBundle.getString("FrameAdmin__actionMap_0__new_ActionMapEntry"),FrameAdminHandler.DELETEDOCUMENT,frameAdminBundle.getString("Dokument__P__wurde_gelscht"));
		_actionMap[1]=new ActionMapEntry(frameAdminBundle.getString("FrameAdmin__actionMap_1__new_ActionMapEntry"),FrameAdminHandler.GETDOCUMENTSFORSPIDER,"");
		_actionMap[2]=new ActionMapEntry(frameAdminBundle.getString("FrameAdmin__actionMap_2__new_ActionMapEntry"),FrameAdminHandler.DELETESPIDER,frameAdminBundle.getString("Daten_fr_Spider__P__wurden_gelscht"));
		_actionMap[3]=new ActionMapEntry(frameAdminBundle.getString("FrameAdmin__actionMap_3__new_ActionMapEntry"),FrameAdminHandler.DELETESUBSERVERBYID,frameAdminBundle.getString("Subserver__P__wurde_gelscht_ID"));
		_actionMap[4]=new ActionMapEntry(frameAdminBundle.getString("FrameAdmin__actionMap_4__new_ActionMapEntry"),FrameAdminHandler.DELETESUBSERVERBYNAME,frameAdminBundle.getString("Subserver__P__wurde_gelscht_Name"));
		_actionMap[5]=new ActionMapEntry(frameAdminBundle.getString("FrameAdmin__actionMap_5__new_ActionMapEntry"),FrameAdminHandler.SHUTDOWN,frameAdminBundle.getString("Server__A__wurde_heruntergefahren"));
		_actionMap[6]=new ActionMapEntry(frameAdminBundle.getString("FrameAdmin__actionMap_6__new_ActionMapEntry"),FrameAdminHandler.RECONFIG,frameAdminBundle.getString("Server__A__wurde_neu_konfiguriert"));
		_actionMap[7]=new ActionMapEntry(frameAdminBundle.getString("FrameAdmin__actionMap_7__new_ActionMapEntry"),FrameAdminHandler.WRITESTAT,frameAdminBundle.getString("Statistik_wurde_nach__P__geschrieben"));
		_actionMap[8]=new ActionMapEntry(frameAdminBundle.getString("FrameAdmin__actionMap_8__new_ActionMapEntry"),FrameAdminHandler.CLEANDB,frameAdminBundle.getString("Datenbank_wurde_bereinigt"));
		for (int i=0;i<_actionMap.length;i++)
		{
		  choiceAction.add(_actionMap[i]._name);
		}
		try { 
			choiceAction.select(0);
		}
		catch (IllegalArgumentException e) { }
	}
	
	ActionMapEntry[] _actionMap=null;
	
	class ActionMapEntry
	{
	  public String _name=null;
	  public int _id=-1;
	  public String _text=null;
	  
	  public ActionMapEntry(String name, int id, String text)
	  {
	    _name=name;
	    _id=id;
	    _text=text;
	  }
	}
}
